// DebugLogp
function DEBUGLOG(log){
	console.log(log);
}
//---------------------------------------------------------------------------------------------------
// URL
//---------------------------------------------------------------------------------------------------
function getUrlVars(){
	var vars = [], hash;
	var hashes=window.location.href.slice(window.location.href.indexOf('?')+1).split('&');
	for(var i= 0;i<hashes.length;i++)
	{
		hash=hashes[i].split('=');
		vars.push(hash[0]);
		vars[hash[0]]=hash[1];
	}
	return vars;
}

//---------------------------------------------------------------------------------------------------
// Local Storage
//---------------------------------------------------------------------------------------------------
// StorageΉmF
function isStoragable(){
	if(typeof(Storage)!=='undefined') return true;
	return false;
}
// f[^̃[h
function loadFromStorage(){
	if(!isStoragable()) return;
	
	var key=0;	
	var isselected=getUrlVars()['select'];
	var urlinsert=getUrlVars()['url'];
	
	if(typeof(isselected)!='undefined'){
		key=isselected;
	}else if(typeof(urlinsert)!='undefined'){
		key=urlinsert;
	}
	
	var data=window.localStorage.getItem(key);
	if(!data) return;
	
	var obj=JSON.parse(data);
	s_segmentClip=obj['segmentClip'];
	s_segment_data=obj['segment_data'];
}
// f[^̕ۑ
function saveToStorage(){
	if(!isStoragable()) return;
	
	var key=0;	
	var isselected=getUrlVars()['select'];
	var urlinsert=getUrlVars()['url'];
	
	if(typeof(isselected)!='undefined'){
		key=isselected;
	}else if(typeof(urlinsert)!='undefined'){
		key=urlinsert;
	}
	
	var data={
		'segmentClip':s_segmentClip,
		'segment_data':s_segment_data
	};
	window.localStorage.setItem(key,JSON.stringify(data));
	
	alert('Motion Data Saved');
}
// [h̏
function initLoadSettings(){
	for(var i=0;i<s_segment_data.length;i++){
		for(var j in s_segment_data[i]){
			if(-1==s_segment_data[i][j]) continue;
			activateClipSegment(i,j);
		}
	}
	
	for(var i=0;i<s_segmentClip.length;i++){
		for(var j=0;j<s_segmentClip[i].length;j++){
			var dat=s_segmentClip[i][j];
			if(-1==dat) continue;
			var clip=$('#clip-'+i+'-'+j);
			clip.addClass("edited-clip");
			clip.css("background-image",s_icon_res[dat]);
		}
	}
}

//---------------------------------------------------------------------------------------------------
// GlobalVars
//---------------------------------------------------------------------------------------------------
var s_player=null;
var motion_ID=[0,1,2,3,4,5,2];
var s_timeline_table=null;

var s_timeline_content_div=8;
var s_timeline_datalength=0;
var s_combination=[];
var s_icon_res={};
var s_play_idx=-1;

//---------------------------------------------------------------------------------------------------
// Danscrollbar֘A
//---------------------------------------------------------------------------------------------------
function initScrollbar(){;
	var player=s_player;
	s_timeline_datalength=player.song.scene.bars.length;
	s_timeline_table.initdatalength(s_timeline_datalength-s_timeline_content_div+1);
}

// Đ̗D揇ʕ]
var s_priority=[1,2,3,4,5,0];
function parseCombinationData(){
	var datanum=s_timeline_datalength;
	s_combination=new Array(datanum);
	var data=s_segment_data;
	for(var i=0;i<datanum;i++){
		var id=6;
		for(var j=0;j<s_priority.length;j++){
			var idx=s_priority[j];
			if(-1==data[idx][i]){id=idx;}
		}
		s_combination[i]=id;
	}
}

function registerTimelineDrop(){
	$('.timelinedrop').droppable({
		drop:function(event,ui){
		
			var data=s_segment_data;
			var dropObj=$(ui.draggable);
			var img=dropObj.css("background-image");
			var targetObj=$(this);		

			var parent=targetObj.parent();
			var rowIndex=parent.parent().children().index(parent)-2;	//  
			var columnIndex=targetObj.index()-1;						// 
			
			var motionText=dropObj.data("command");
			var motionIndex=DEFAULT_MOTION_ID;
			
			var startidx=$($('#beatrow_main div:nth-child(2)')[0]).data('idx');
			var droppedidx=startidx+columnIndex;
			
			if(motionText==="Revert"){
				var defaultmotion=1;
				if(rowIndex==6){
					defaultmotion=0;
					if(s_segmentClip[6][0]!=-1){defaultmotion=s_segmentClip[6][0];}
				}
				else if(rowIndex!=0){
					defaultmotion=rowIndex+1;
				}
				motionIndex=-1;
				img=$("#drag"+motion_ID[defaultmotion]).css("background-image");
				targetObj.removeClass("edited-timeline");
			}else{
				motionIndex=parseInt(motionText.split('_')[1]);
				
				targetObj.addClass("edited-timeline");
			}
			
			activateClipSegment(rowIndex,droppedidx);
			data[rowIndex][droppedidx]=motionIndex;
			$(this).css("background-image",img);
		}
	});
}

// Se[u\̍쐬
function filltable(){
	var self=s_timeline_table.instance();
	var lastidx=self.screndidx;
	var data=s_segment_data;
	var datanum=s_timeline_datalength;
	var div;
	
	var dropclass='timelinedrop';
	var currdiv=$('#beatrow_main div').length-1;
	while(currdiv++<s_timeline_content_div){
		var dataidx=lastidx;
		if(lastidx>datanum-1){break;}
		
		// beatrow_0
		div=document.createElement('div');
		div.className='beatcell_content';
		if(typeof data[0][lastidx]!='undefined') div.className+=' beatrow_0a '+dropclass;
		if(data[0][dataidx]==-1){
			var seg=getTimelineSegment(0,dataidx);
			var clip=s_segmentClip[0][seg];
			if(clip==-1){clip=1;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[0][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_0 div:last').after(div);
		
		
		// beatrow_1
		div=document.createElement('div');
		div.className='beatcell_content';
		if(typeof data[1][lastidx]!='undefined') div.className+=' beatrow_1a '+dropclass;
		if(data[1][dataidx]==-1){
			var seg=getTimelineSegment(1,dataidx);
			var clip=s_segmentClip[1][seg];
			if(clip==-1){clip=2;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[1][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_1 div:last').after(div);
		
		// beatrow_2
		div=document.createElement('div');
		div.className='beatcell_content';
		if(typeof data[2][lastidx]!='undefined') div.className+=' beatrow_2a '+dropclass;
		if(data[2][dataidx]==-1){
			var seg=getTimelineSegment(2,dataidx);
			var clip=s_segmentClip[2][seg];
			if(clip==-1){clip=3;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[2][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_2 div:last').after(div);
		
		// beatrow_3
		div=document.createElement('div');
		div.className='beatcell_content';
		if(typeof data[3][lastidx]!='undefined') div.className+=' beatrow_3a '+dropclass;
		if(data[3][dataidx]==-1){
			var seg=getTimelineSegment(3,dataidx);
			var clip=s_segmentClip[3][seg];
			if(clip==-1){clip=4;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[3][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_3 div:last').after(div);
		
		// beatrow_4
		div=document.createElement('div');
		div.className='beatcell_content';
		if(typeof data[4][lastidx]!='undefined') div.className+=' beatrow_4a '+dropclass;
		if(data[4][dataidx]==-1){
			var seg=getTimelineSegment(4,dataidx);
			var clip=s_segmentClip[4][seg];
			if(clip==-1){clip=5;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[4][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_4 div:last').after(div);
		
		// beatrow_5
		div=document.createElement('div');
		div.className='beatcell_content';
		if(typeof data[5][lastidx]!='undefined') div.className+=' beatrow_5a '+dropclass;
		if(data[5][dataidx]==-1){
			var seg=getTimelineSegment(5,dataidx);
			var clip=s_segmentClip[5][seg];
			if(clip==-1){clip=2;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[5][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_5 div:last').after(div);
		
		// beatrow_6
		div=document.createElement('div');
		div.className='beatcell_content beatrow_6a '+dropclass;
		if(data[6][dataidx]==-1||typeof data[6][dataidx]==='undefined'){
			var clip=s_segmentClip[6][0];
			if(clip==-1){clip=0;}
			backgroundimg=s_icon_res[clip];
		}else{
			backgroundimg=s_icon_res[data[6][dataidx]]||'';
			if(backgroundimg!='') div.className+=' edited-timeline';
		}
		div.style.backgroundImage=backgroundimg;
		$('#beatrow_6 div:last').after(div);
		
		// beatrow_main
		div=document.createElement('div');
		div.className='beatcell_content timelineidx'+' beatrow_'+s_combination[lastidx]+'a';
		if(s_play_idx==dataidx){
			div.className+=' active-clip';
		}
		div.setAttribute('data-idx',lastidx);
		div.innerHTML=dataidx; //
		$('#beatrow_main div:last').after(div);
		
		lastidx++;
	}
	self.screndidx=lastidx;
	registerTimelineDrop();
}
// e[uJ̑O쐬
function fillfront(){
	var self=s_timeline_table.instance();
	var data=s_segment_data;
	
	var dataidx=self.scrstartidx;
	$('#beatrow_main div:last,#beatrow_0 div:last,#beatrow_1 div:last,#beatrow_2 div:last,#beatrow_3 div:last,#beatrow_4 div:last,#beatrow_5 div:last,#beatrow_6 div:last').remove();
	
	var dropclass='timelinedrop';
	var backgroundimg='';
	
	// beatrow_0
	var div=document.createElement('div');
	div.className='beatcell_content';
	if(typeof data[0][dataidx]!='undefined') div.className+=' beatrow_0a '+dropclass;
	if(data[0][dataidx]==-1){
		var seg=getTimelineSegment(0,dataidx);
		var clip=s_segmentClip[0][seg];
		if(clip==-1){clip=1;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[0][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;
	$('#beatrow_0 div:first').after(div);

	// beatrow_1
	div=document.createElement('div');
	div.className='beatcell_content';
	if(typeof data[1][dataidx]!='undefined') div.className+=' beatrow_1a '+dropclass;
	if(data[1][dataidx]==-1){
		var seg=getTimelineSegment(1,dataidx);
		var clip=s_segmentClip[1][seg];
		if(clip==-1){clip=2;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[1][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;	
	$('#beatrow_1 div:first').after(div);

	// beatrow_2
	div=document.createElement('div');
	div.className='beatcell_content';
	if(typeof data[2][dataidx]!='undefined') div.className+=' beatrow_2a '+dropclass;
	if(data[2][dataidx]==-1){
		var seg=getTimelineSegment(2,dataidx);
		var clip=s_segmentClip[2][seg];
		if(clip==-1){clip=3;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[2][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;	
	$('#beatrow_2 div:first').after(div);
	
	// beatrow_3
	div=document.createElement('div');
	div.className='beatcell_content';
	if(typeof data[3][dataidx]!='undefined') div.className+=' beatrow_3a '+dropclass;
	if(data[3][dataidx]==-1){
		var seg=getTimelineSegment(3,dataidx);
		var clip=s_segmentClip[3][seg];
		if(clip==-1){clip=4;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[3][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;
	$('#beatrow_3 div:first').after(div);
	
	// beatrow_4
	div=document.createElement('div');
	div.className='beatcell_content';
	if(typeof data[4][dataidx]!='undefined') div.className+=' beatrow_4a '+dropclass;
	if(data[4][dataidx]==-1){
		var seg=getTimelineSegment(4,dataidx);
		var clip=s_segmentClip[4][seg];
		if(clip==-1){clip=5;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[4][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;
	$('#beatrow_4 div:first').after(div);

	// beatrow_5
	div=document.createElement('div');
	div.className='beatcell_content';
	if(typeof data[5][dataidx]!='undefined') div.className+=' beatrow_5a '+dropclass;
	if(data[5][dataidx]==-1){
		var seg=getTimelineSegment(5,dataidx);
		var clip=s_segmentClip[5][seg];
		if(clip==-1){clip=2;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[5][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;
	$('#beatrow_5 div:first').after(div);
	
	// beatrow_6
	div=document.createElement('div');
	div.className='beatcell_content beatrow_6a '+dropclass;
	if(data[6][dataidx]==-1||typeof data[6][dataidx]==='undefined'){
		var clip=s_segmentClip[6][0];
		if(clip==-1){clip=0;}
		backgroundimg=s_icon_res[clip];
	}else{
		backgroundimg=s_icon_res[data[6][dataidx]]||'';
		if(backgroundimg!='') div.className+=' edited-timeline';
	}
	div.style.backgroundImage=backgroundimg;
	$('#beatrow_6 div:first').after(div);
	
	// beatrow_main
	div=document.createElement('div');
	div.className='beatcell_content timelineidx'+' beatrow_'+s_combination[dataidx]+'a';
	if(s_play_idx==dataidx){
		div.className+=' active-clip';
	}
	div.setAttribute('data-idx',dataidx);
	div.innerHTML=dataidx; //
	$('#beatrow_main div:first').after(div);
	
	self.screndidx--;
	registerTimelineDrop();
}
// XN[ɂ\
function adjusttableview(){
	var self=s_timeline_table.instance();
	if(self.scrlastidx==self.scrstartidx) return;
	if(self.scrstartidx>self.scrlastidx){
		$('#beatrow_main div:first,#beatrow_0 div:first,#beatrow_1 div:first,#beatrow_2 div:first,#beatrow_3 div:first,#beatrow_4 div:first,#beatrow_5 div:first,#beatrow_6 div:first').next().remove();
	}
	else{
		fillfront();
	}
	self.scrlastidx=self.scrstartidx;
}
// e[u\̔j
function destroytableview(){
	var self=s_timeline_table.instance();
	self.screndidx=self.scrstartidx;
	self.scrlastidx=self.scrstartidx;
	$('#beatrow_main div:first,#beatrow_0 div:first,#beatrow_1 div:first,#beatrow_2 div:first,#beatrow_3 div:first,#beatrow_4 div:first,#beatrow_5 div:first,#beatrow_6 div:first').nextAll().remove();
}
// hbOɂr[
function adjusttabledragview(){
	var self=s_timeline_table.instance();
	if(self.scrlastidx==self.scrstartidx)return;
	self.screndidx=self.scrstartidx;
	self.scrlastidx=self.scrstartidx;
	destroytableview();
}
function refreshTableView(){
	destroytableview();
	filltable();
	s_timeline_table.resize();
}
// XN[o[ɂhbO
function dragging(){
	adjusttabledragview();
	filltable();
}
// XN[o[ɂXN[
function scrolling(){
	adjusttableview();
	filltable();
}
// XN[o[̏
function initDanScrollbar(){
	s_timeline_table = new DanScrollbar({
		maincontainer:'#table-area',
		mousescroll:'#table-area,#scrollbarContainer',
		scrollbarcontainer:'#scrollbarContainer',
		scrollbar:'#scrollbar',
		scrollfunc:scrolling,
		dragfunc:dragging,
		axis:'x',
		preventdefault:1
	});
	s_timeline_table.initscrollbar();
}
// e[uvf\̒ : X^Ch~
function reInitTableStyle(){
	$('.beatcell_header').css("display","table-cell");
}
// EBhETCYΉ
$(window).resize(function(){
	if(s_timeline_table) s_timeline_table.resize();
});

//---------------------------------------------------------------------------------------------------
// Songle֘A
//---------------------------------------------------------------------------------------------------
// \O[h̏
var onSongleWidgetReady = function(apiKey,player){
	var initialize = function(dom){
		loadExternalLibrary(dom,function(){
			exacuteSongleWidget(apiKey,player);
		});
	}
	
	//-----------------------------
	// ֘A
	//-----------------------------
	// OCuǂݍ
	var loadExternalLibrary = function(dom,onImport){
		DEBUGLOG("Loading External Libraries\n");
		var d=document.createDocumentFragment();
		var xmlhttp=document.createElement("script");
		var danscrollbar=document.createElement("script");
		
		// xmlhttp
		xmlhttp.src="xmlhttp.js";
		d.appendChild(xmlhttp);

		// danscrollbar
		danscrollbar.addEventListener("load",onImport);
		danscrollbar.src="./libs/js/danscrollbar.min.js";
		//danscrollbar.src="./libs/js/danscrollbar.js";
		d.appendChild(danscrollbar);
		
		dom.appendChild(d);
	}
	initialize(document.getElementsByTagName("body")[0]);
}
// Nbvf[^̊l
var s_segmentClip=null;
var s_segment_data=[{},{},{},{},{},{},{}];
function parseClipSegments(){
	var player=s_player;
	
	// ȈՃ[Vp
	var segments=player.song.scene.repeatSegments.length;
	s_segmentClip=new Array(segments+1);
	for(var i=0;i<segments;++i){
		var subsegments=player.song.scene.repeatSegments[i].repeats.length;
		s_segmentClip[i]=new Array(subsegments);
		for(var j=0;j<subsegments;j++){
			s_segmentClip[i][j]=-1;
		}
	}
	// ftH[g[Vp
	s_segmentClip[segments]=[-1];
	
	// ^CC[Vp
	var segment_data=s_segment_data;
	for(var i=0;i<segment_data.length-1;i++){
		var repeatindex=0;
		var repeatlength=player.song.scene.repeatSegments[i].repeats.length;
		var duration=player.song.scene.repeatSegments[i].duration;
		var init=false;
		for(var j=0;j<player.song.scene.bars.length;j++){
			if(repeatindex>=repeatlength) break;
			
			var start=player.song.scene.bars[j].start;
			var keystart=player.song.scene.repeatSegments[i].repeats[repeatindex].start;
			if(start>=keystart&&start<=keystart+duration){
				s_segment_data[i][j]=-1;
				init=true;
				continue;
			}
			if(true==init){
				init=false;
				repeatindex++;
			}
		}
	}
}
// AgZbg
function resetTimelineSegment(index,segment){
	if(index==6){
		s_segment_data[index]={};
	}else{
		var seg=0;
		var last_data=0;
		var first=true;
		for(var i in s_segment_data[index]){
			if(seg==segment){
				s_segment_data[index][i]=-1;
			}
			
			if(first==true){
				first=false;
				last_data=i;
				continue;
			}
			if(i-last_data!=1){
				last_data=i;
				if(++seg>segment) break;
			}
			last_data=i;
		}
	}
}
// AgZOg
function activateClipSegment(index,timelineindex){
	if(index==6){
		$('#clip-6-0').addClass("edited-clip");
	}else{
		var first=true;
		var last_data=0;
		var seg=0;
		for(var i in s_segment_data[index]){
			if(timelineindex==i){
				if(first==false) ++seg;
				break;	
			}
			
			if(first==true){
				first=false;
				last_data=i;
				continue;
			}
			if(i-last_data!=1){
				++seg;
			}
			last_data=i;
		}
		$('#clip-'+index+'-'+seg).addClass("edited-clip");
	}
}
// Segmenẗʒuo
function getTimelineSegment(index,timelineindex){
	var first=true;
	var last_data=0;
	var seg=0;
	for(var i in s_segment_data[index]){
		if(timelineindex==i) break;
	
		if(first==true){
			first=false;
			last_data=i;
			continue;
		}
		if(i-last_data!=1){
			++seg;
		}
		last_data=i;
	}
	return seg;
}
// ACR̊l
function getIconResource(){
	$('#motion-group').find('div').each(function(index){
		var target=$(this);
		var data=target.data("command");
		var res=target.css("background-image");
		if(data){
			var data_id=parseInt(data.split('_')[1]);
			if(!isNaN(data_id)) s_icon_res[data_id]=res;
		}
	});
}
var DEFAULT_MOTION_ID=-1;
var DISABLE_MOTION_ID=-2;
// x[VbNNbv\̍쐬
function createClipSegment(){
	// "#clip-segment"
	var segmentText=["Tr","ԂP","ԂQ","ԂR","ԂS","ԂT","ftHg"];
	var d=document.createDocumentFragment();
	var parent,div;
	
	var cliplength=s_segmentClip.length;
	for(var i=0;i<cliplength;i++){
		parent=document.createElement("div");
		parent.className+="clip-group";
		
		div=document.createElement("div");
		div.innerHTML=segmentText[i];
		div.className+="parent-clip";
		$(parent).append(div);
		
		var background=$("#drag"+motion_ID[i+1]).css("background-image");
		if(i==0){
			background=$("#drag"+motion_ID[1]).css("background-image");
		}else if(i==6){
			background=$("#drag"+motion_ID[0]).css("background-image");
		}
		
		for(var j=0;j<s_segmentClip[i].length;j++){
			div=document.createElement("div");
			div.style.backgroundImage=background;
			div.className+="clip clipdrop";
			div.id="clip-"+i+"-"+j;
			$(parent).append(div);
		}

		$(d).append(parent);
	}
	
	$("#clip-segment").append(d);
	$(".clipdrop").droppable({
		drop:function(event,ui){
		
			var dropObj=$(ui.draggable);
			var img=dropObj.css("background-image");
			var targetObj=$(this);

			var parent=targetObj.parent();
			var rowIndex=parent.parent().children().index(parent);
			var columnIndex=targetObj.index()-1;	// Ă
			
			var motionText=dropObj.data("command");
			var motionIndex=DEFAULT_MOTION_ID;
			
			if(motionText==="Revert"){
				var defaultmotion=1;
				if(rowIndex==6){defaultmotion=0;}
				else if(rowIndex!=0){defaultmotion=rowIndex+1;}
				img=$("#drag"+motion_ID[defaultmotion]).css("background-image");
				targetObj.removeClass("edited-clip disable-clip");
				resetTimelineSegment(rowIndex,columnIndex);
			}else{
				motionIndex=parseInt(motionText.split('_')[1]);
				targetObj.removeClass("disable-clip");
				targetObj.addClass("edited-clip");
			}
			s_segmentClip[rowIndex][columnIndex]=motionIndex;
			$(this).css("background-image",img);
		}
	});
}
// r[g֘A
var s_timingOffset=0;
function changeTimingOffset(offset){
	s_timingOffset=parseInt(offset,10);
	if(s_player){
		s_player.beatEventTimingOffset   = -s_timingOffset;
		s_player.chordEventTimingOffset  = -s_timingOffset;
		s_player.chorusEventTimingOffset = -s_timingOffset;
		s_player.noteEventTimingOffset   = -s_timingOffset;
		s_player.repeatEventTimingOffset = -s_timingOffset;	
	}
}
// \O̎s
var exacuteSongleWidget = function(apiKey,player){
	initTouchRelated();
	initDanScrollbar();
	
	//-----------------------------
	// Cxg֘Aݒ
	//-----------------------------
	player.on("beatPlay",function(e){	
		switch(e.beat.position){
			case 1:
				$('#beat').text("");
				
				var baridx=e.bar.index;
				s_play_idx=baridx;
				
				var clipname="#clip-";
				var flg_decided=0;
				var time_now = (e.bar.next.start+e.bar.start)/2;
				for(var i=0; i<player.song.scene.repeatSegments[0].repeats.length;i++)
					if(time_now >= player.song.scene.repeatSegments[0].repeats[i].start
					&& time_now < player.song.scene.repeatSegments[0].repeats[i].start
				  +player.song.scene.repeatSegments[0].repeats[i].duration)
				{
					var timeslice=parseInt(e.bar.next.start-e.bar.start);
					var timelinemotion=s_segment_data[0][baridx];
					var usersettings=s_segmentClip[0][i];
					if(usersettings==-2) break;
					
					if(timelinemotion!=-1&&typeof timelinemotion!='undefined'){
						sendAnimeNum(timelinemotion,timeslice);
					}else{
						if(usersettings==-1){
							sendAnimeNum(motion_ID[1],timeslice);
						}else{
							sendAnimeNum(usersettings,timeslice);
						}
					}
					flg_decided=1;
					clipname+="0-"+i;
					$(clipname).addClass("active-clip");
					break;
				}
				if(flg_decided==0){
					hoge:
					for(var j=player.song.scene.repeatSegments.length-1; j>0;j--){
						for(var i=0; i<player.song.scene.repeatSegments[j].repeats.length;i++){
							if(time_now >= player.song.scene.repeatSegments[j].repeats[i].start
								&& time_now < player.song.scene.repeatSegments[j].repeats[i].start
							+player.song.scene.repeatSegments[j].repeats[i].duration)
							{
								// [U[w肠肩ǂ
								var timeslice=parseInt(e.bar.next.start-e.bar.start);
								var timelinemotion=s_segment_data[j][baridx];
								var usersettings=s_segmentClip[j][i];
								if(usersettings==-2) break;
								
								if(timelinemotion!=-1&&typeof timelinemotion!='undefined'){
									sendAnimeNum(timelinemotion,timeslice);
								}else{
									if(usersettings==-1){
										sendAnimeNum(motion_ID[j+1],timeslice);
									}else{
										sendAnimeNum(usersettings,timeslice);
									}
								}
								flg_decided=1;
								clipname+=j+"-"+i;
								$(clipname).addClass("active-clip");
								break hoge;
							}
						}
					}
				}
				if(flg_decided==0){
					var timeslice=parseInt(e.bar.next.start-e.bar.start);
					var timelinemotion=s_segment_data[6][baridx];
					var usersettings=s_segmentClip[6][0];
					
					// timeline
					if(timelinemotion!=-1&&typeof timelinemotion!='undefined'){
						sendAnimeNum(timelinemotion,timeslice);
					}else{
						// basic
						if(usersettings!=-1){
							sendAnimeNum(usersettings,timeslice);
						}else{
							sendAnimeNum(motion_ID[0],timeslice);
						}
					}
					$('#clip-6-0').addClass("active-clip");
				}
				
				if($('#timeline-segment').is(':visible')==true){
					
					$('.active-clip').removeClass("active-clip");
					
					var startidx=$($('#beatrow_main div:nth-child(2)')[0]).data('idx');
					var endidx=startidx+s_timeline_content_div-1;
					var curridx=0;
					if(baridx<startidx||baridx>endidx){
						var maxmin=s_timeline_table.instance().datanum;
						if(baridx>maxmin){
							s_timeline_table.setindex(maxmin-1);
							curridx=-1;
						}else{
							s_timeline_table.setindex(baridx);
						}
						refreshTableView();
					}else{
						curridx=baridx-startidx;
					}
					
					if(-1!=curridx) $('#beatrow_main div:nth-child('+(2+curridx)+')')[0].className+=' active-clip';
				}
				break;
			case 2:
				$('#beat').text("");
				break;
			case 3:
				$('#beat').text("");
				
				if($('#timeline-segment').is(':visible')==false){
					var clip=$(".active-clip");
					for(var i=0;i<clip.size();i++){
						$(clip[i]).removeClass("active-clip");
					}
				}
				break;
			case 4:
				$('#beat').text("");
				break;
		}
	});
	
	// vC[CX^X̊l
	s_player=player;
	
	// SegmentDatål
	parseClipSegments();
	// load
	loadFromStorage();
	
	// Segment̓I쐬
	// "#clip-segment"
	getIconResource();
	createClipSegment();
	
	// ClipɕύX_𔽉f
	initLoadSettings();
	
	// DanScrollbar̗vfݒ
	initScrollbar();
	parseCombinationData();
	reInitTableStyle();
	filltable();
	
	//player.play();
}

function executeplay(){
	s_player.play();
	$('#playbtn').hide();
	$('#pausebtn').show();
}
function executepause(){
	s_player.pause();
	$('#playbtn').show();
	$('#pausebtn').hide();
}
function seekbegin(){
	var player=s_player;
	player.stop();
	executeplay();
}

//---------------------------------------------------------------------------------------------------
// V-SIDO֘A
//---------------------------------------------------------------------------------------------------
var touch_x=[0,0,0,0,0];
var touch_y=[0,0,0,0,0];
var touch_num=0;
var touch_home_x=[1,160,299,0,0];
var touch_home_y=[1,100,1,0,0];
var touch_touched=[false,false,false,false,false];

function initTouchRelated(){
	touch_init();
	accel_init();
}

var pos_x,pos_y,pos_z;
function accel_init(){
	window.addEventListener("devicemotion",iosHandleOrientation,true);
	pos_x=pos_y=pos_z=0;
}

function iosHandleOrientation(event){
	var orientData=event.accelerationIncludingGravity;
	var accel_scale=30.0;
	var filter_val=0.1;
	
	pos_x=(orientData.x*accel_scale*filter_val)+(pos_x*(1.0-filter_val));
	pos_y=(-orientData.y*accel_scale*filter_val)+(pos_y*(1.0-filter_val));
	pos_z=(orientData.z*accel_scale*filter_val)+(pos_z*(1.0-filter_val));
}

function touch_init(){
	document.addEventListener("touchstart",touch_move,false);
	document.addEventListener("touchmove",touch_move,false);
	document.addEventListener("touchend",touch_move,false);
	
	for(var i=0;i<touch_home_x.len;i++){
		touch_x[i]=touch_home_x[i];
		touch_y[i]=touch_home_y[i];
	}
}

function touch_move(event){
	touch_num=event.touches.length;
	var _touch_touched=[false,false,false,false,false];
	
	for(var i=0;i<3;i++){
		var min_ID=i;
		var min_val=1000000;
		if(event.touches[i]){
			var touch_xx=event.touches[i].pageX;
			var touch_yy=event.touches[i].pageY;
			
			for(var j=0;j<3;j++){
				var home_xx=touch_home_x[j];
				var home_yy=touch_home_y[j];
				
				var dstn=(touch_xx-home_xx)*(touch_xx-home_xx)+
					(touch_yy-home_yy)*(touch_yy-home_yy);
				if(dstn<min_val){
					min_ID=j;
					min_val=dstn;
				}
			}
			
			min_ID=1;
			touch_x[min_ID]=(touch_x[min_ID]+touch_xx)/2.0;
			touch_y[min_ID]=(touch_y[min_ID]+touch_yy)/2.0;
			_touch_touched[min_ID]=true;
		}
	}
	for(var k=0;k<_touch_touched.len;k++){
		touch_touched[k]=_touch_touched[k];
		event.preventDefaullt();
	}
}

function sendTouchData(){
	var j=1;
	if(touch_touched[j]==false){
		touch_x[j]=Math.floor((touch_x[j]+touch_home_x[j])/2);
		touch_y[j]=Math.floor((touch_y[j]+touch_home_y[j])/2);
	}
	
	var outtext="xy";
	for(var i=0;i<3;i++){
		if(i==1){
			outtext+="_"+parseInt(touch_x[i]-touch_home_x[i])+"_"+parseInt(touch_y[i]-touch_home_y);
		}else{
			outtext+="_0_0"
		}
	}
	outtext+="_ac_"+parseInt(pos_x)+"_"+parseInt(pos_z)+"_"+parseInt(pos_y);
	document.getElementById("result1").innerHTML=outtext;
	loadTextFile();
}

function sendBeatData(numX,numY){
	var outtext="xy";
	for(var i=0;i<3;i++){
		outtext+="_"+parseInt(numX)+"_"+parseInt(numY);
	}
	outtext+="_ac_"+parseInt(pos_x)+"_"+parseInt(pos_z)+"_"+parseInt(pos_y);
	document.getElementById("result1").innerHTML=outtext;
	loadTextFile();
}

function sendBeatData2(spz,rhx,rhz,lhx,lhz,rfx,rfy,lfx,lfy,wkx,wky){
	var outtext="xy";
	outtext+="_0_"+parseInt(spz);
	outtext+="_"+parseInt(rhx)+"_"+parseInt(rhz);
	outtext+="_"+parseInt(lhx)+"_"+parseInt(lhz);
	outtext+="_"+parseInt(rfx)+"_"+parseInt(rfy);
	outtext+="_"+parseInt(lfx)+"_"+parseInt(lfy);
	outtext+="_ac_"+parseInt(wkx)+"_"+parseInt(wky);
	document.getElementById("result1").innerHTML=outtext;
	loadTextFile();
}

function sendAnimeNum(numAnime,sec){
	var outtext="ANIME";
	outtext+="_"+parseInt(numAnime)+"_"+parseInt(sec);
	document.getElementById("result1").innerHTML=outtext;
	loadTextFile();
}

function dataSend(){
	var textData=document.ajaxForm.request.value;
	httpObj=createXMLHttpRequest(displayData);
	if(httpObj){
		httpObj.open("GET","save.rb?request="+textData,true);
		httpObj.send(null);
	}
}

function walkStart(){
	var textData=document.ajaxForm.request.value;
	httpObj=createXMLHttpRequest(displayData);
	if(httpObj){
		httpObj.open("GET","save.rb?request=walk",true);
		httpObj.send(null);
	}
}

function walkStop(){
	var textData=document.ajaxForm.request.value;
	httpObj=createXMLHttpRequest(displayData);
	if(httpObj){
		httpObj.open("GET","save.rb?request=stop",true);
		httpObj.send(null);
	}
}
